unit AppDlgs;
Interface
uses Dos,App,Objects,Dialogs,Drivers,Views,AppConst,StdDlg;
const
  CClickTester = #7#8;
  {Mouse Dialog}
  {Palette layout}
  { 0 = Unclicked }
  { 1 = Clicked }

type
TranspDlgData=record
              str:string[2];
              end;
PTranspDialog=^TTranspDialog;
TTranspDialog=object(TDialog)
Transp:Word;
Constructor Init(tr:word);
Procedure HandleEvent(var E:TEvent);Virtual;
end;

TTempDlgData=record
             str :string[5];
             str1:string[6]
             end;
PTempDialog=^TTempDialog;
TTempDialog=object(TDialog)
Temp:Word;
Rat :real;
Constructor Init(tm:word);
Procedure HandleEvent(var E:TEvent);Virtual;
end;


PGraphicLine=^TGraphicLine;
TGraphicLine=object(TView)
Limit:TPoint;
CurPos:word;
Constructor Init(var R:TRect;Min,Max,IniValue:Integer);
Procedure HandleEvent(var E:TEvent);Virtual;
Procedure Draw;Virtual;
Function  GetPalette:PPalette;Virtual;
Procedure Add(P:Integer);
Procedure Subtruct(P:Integer);
Procedure SetPos(P:Integer);
end;


PMyChdirDialog=^TMyChdirDialog;
TMyChdirDialog=Object(TChDirDialog)
Constructor Init(A,H:Word);
End;

PMyFileDialog=^TMyFileDialog;
TMyFileDialog=object(TFileDialog)
Constructor Init(AW:FNameStr;ATitle,InputName:string;AO:word;HI:byte);
Destructor Done;virtual;
End;

OptFileStr=String[3];
OptFileRec=Record
           AccWriteAnn,
           AccWriteCom:OptFileStr;
           kbComStop,
           WriteHeader,
           OpenIntoEmpty:word
           end;

POptFileDialog=^TOptFileDialog;
TOptFileDialog=object(TDialog)
Constructor Init;
End;

OptEditStr=String[3];
OptEditRec=Record
           TempIncr:OptEditStr;
           MarkMovesDown:WordBool;
           TMChangeAll:word;
           TRChangeAll:word;
           end;
POptEditDialog=^TOptEditDialog;
TOptEditDialog=object(TDialog)
Constructor Init;
End;


OptPlayStr=string[3];
OptPlayStr1=string[5];
OptPlayRec=record
           AccCnt:OptPlayStr;
           POTMDiv,POTRMult:OptPlayStr1;
           AutoSetup:word;
           Blinking:wordbool
           end;

POptPlayDialog=^TOptPlayDialog;
TOptPlayDialog=object(TDialog)
Constructor Init;
Procedure HandleEvent(var E:TEvent);virtual;
end;


OptPrefPrefRec=record
               ScreenRes:word;
               AutoSaveReturn:Word;
               ScrMode:word;
               end;
POptPrefDialog=^TOptPrefDialog;
TOptPrefDialog=object(TDialog)
Constructor Init;
End;


PClickTester = ^TClickTester;
TClickTester = object(TStaticText)
  Clicked: Boolean;
  constructor Init(var Bounds: TRect; AText: String);
  function GetPalette: PPalette; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure Draw; virtual;
end;

PMouseDialog = ^TMouseDialog;
TMouseDialog = object(TDialog)
  MouseScrollBar: PScrollBar;
  OldDelay: Word;
  constructor Init;
  procedure HandleEvent(var Event: TEvent); virtual;
end;

PAboutDialog = ^TAboutDialog;
TAboutDialog = object(TDialog)
constructor Init;
end;



{PAutoButton=^TAutoButton;
TAutoButton=object(TButton)
Constructor Init(var Bounds: TRect; ATitle: TTitleStr;ACommand: Word; AFlags: Word);
Procedure HandleEvent(var E:TEvent);virtual;
end;}

{TSysInfoDlg=object(TDialog)
Constructor Init;
end;}

Function  StripFileName(FName:String):String;
Function  StripTitle(FName:String):String;
Function  FileExists(S:String):boolean;
Function  ValidFileName(s:string):boolean;
Procedure GetFileName(var S:string;Mask:string);
Procedure ChangeDir;
Function  MessageBox(const msg:string;Params:Pointer;AOptions:Word):Word;

Implementation

Function  StripFileName(FName:String):String;
var i:byte;
    s:string;
    d:dirstr;
    n:Namestr;
    e:extstr;
begin
s:=FExpand('');
fsplit(fname,d,n,e);
if(FName[2]=':')and(FName[1]<>s[1])then begin StripFileName:=Copy(d,1,2)+n+e;
                                              exit;
                                        end;
i:=1;
while(s[i]=FName[i])and(I<=Length(s))and(I<=Length(FName))do inc(i);
if i<length(s) then StripFileName:=copy(d,3,length(d))+n+e
               else StripFileName:=copy(fname,i,length(fname));
end;


Function StripTitle;
var d:dirstr;
    n:Namestr;
    e:extstr;
begin
fsplit(fname,d,n,e);
StripTitle:=n+e
end;


Function FileExists(S:String):boolean;
var F:File;
    I:byte;
Begin
FileExists:=False;
if s='' then exit;
{$I-}
Assign(f,s);
I:=FileMode;
FileMode:=0;
reset(f,1);
close(f);
FileMode:=i;
FileExists:=Ioresult=0
end;

Function  ValidFileName(s:string):boolean;
var F:File;
Begin
ValidFileName:=False;
if s='' then exit;
{$I-}
if FileExists(s)then begin ValidFileName:=True; exit end;
Assign(f,s);
rewrite(f,1);
close(f);
erase(f);
ValidFileName:=Ioresult=0
end;

Procedure  GetFileName(var S:string;Mask:string);
var PF:PMyFileDialog;
    Control:word;
Begin
if Application=Nil then Exit;
New(PF,Init(Mask,ChooseStr,FileNameStr,fdOpenButton,FileHist));
Control:=Application^.ExecuteDialog(PF,@S);
if control=cmCancel then s:='';
end;

Procedure ChangeDir;
var PD:PMyChDirDialog;
    control:word;
    DirName:string[128];
Begin
New(PD,Init(cdNormal,DirHist));
Control:=DeskTop^.ExecView(PD);
if control<>cmCancel then ChDir(PD^.DirInput^.Data^);
Dispose(PD,Done);
End;


Constructor TTranspDialog.Init;
var  R:TRect;
     PI:PInputLine;
     PB:PButton;
Begin
R.Assign(10,8,70,17);
Inherited Init(R,EditTranspHeaderStr);
  R.Assign(3,3,52,4);
  Insert(New(PGraphicLine,Init(R,0,99,Tr)));

  R.Assign(37,6,46,8);
  PB:=New(PButton,Init(R,'~+~ '#24,cmTDlgPlus,bfNormal));
  PB^.HelpCtx:=hcDlg+hcTRPlus;
  Insert(PB);
  R.Assign(47,6,56,8);
  PB:=New(PButton,Init(R,'~-~ '#25,cmTDlgMinus,bfNormal));
  PB^.HelpCtx:=hcDlg+hcTRMinus;
  Insert(PB);

  R.Assign(2+Length(EditTranspLabelStr),1,6+Length(EditTranspLabelStr),2);
  PI:=New(PInputLine,Init(R,2));
  PI^.HelpCtx:=hcDlg+hcTRInputLine;
  Insert(PI);

  R.Assign(2,1,2+Length(EditTranspLabelStr),2);
  Insert(New(PLabel,Init(R,EditTranspLabelStr,PI)));

  R.Assign(1,6,10,8);
  PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
  PB^.HelpCtx:=hcDlg+hcTROkButton;
  Insert(PB);
  R.Assign(11,6,25,8);
  PB:=New(PButton,Init(R,'Change ~A~ll',cmTDlgChangeAll,bfNormal));
  PB^.HelpCtx:=hcDlg+hcTRChangeAll;
  Insert(PB);
  R.Assign(26,6,36,8);
  PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
  PB^.HelpCtx:=hcDlg+hcCancelButton;
  Insert(PB);

  SelectNext(True);
  SelectNext(True);
End;

Procedure TTranspDialog.HandleEvent;
var code:integer;
    s:string[2];
Begin
Inherited HandleEvent(E);
val(PInputline(Last^.Next^.Next^.Next^.Next^.Next)^.Data^,Transp,Code);
if(E.What=evKeyDown)and(Phase=phPostProcess)then
begin
E.What:=evCommand;
case E.KeyCode of
kbUp,kbRight :E.Command:=cmTDlgPlus ;
kbLeft,kbDown:E.Command:=cmTDlgMinus;
end{case}
end;{if}
str(transp,s);
if(E.What=evCommand)then
case E.Command of
cmTDlgPlus      : if Transp<99 then Inc(Transp);
cmTDlgMinus     : if Transp>00 then Dec(Transp);
cmTDlgChangeAll : EndModal(cmTDlgChangeAll)
else s:=''
end else s:='';

with PInputline(Last^.Next^.Next^.Next^.Next^.Next)^ do
begin
if(s<>'')or(code<>0)then
             begin
             str(transp,s);
             Data^:=s;
             draw
             end;
val(Data^,Transp,Code);
end;
if code=0 then PGraphicLine(Last^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next)^.setpos(Transp);
end;



Constructor TTempDialog.Init;
Var  R:TRect;
     PI,PI1:PInputLine;
     PB:PButton;
Begin
R.Assign(10,7,70,16);
Inherited Init(R,EditTempHeaderStr);
R.Assign(1,3,59,4);
Insert(New(PGraphicLine,Init(R,1,MaxTemp,tm)));

R.Assign( 2,6,10,8);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcDlg+hcTMOKButton;
Insert(PB);
R.Assign(11,6,21,8);
PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
PB^.HelpCtx:=hcDlg+hcCancelButton;
Insert(PB);
R.Assign(22,6,36,8);
PB:=New(PButton,Init(R,'Change ~A~ll',cmTDlgChangeAll,bfNormal));
PB^.HelpCtx:=hcDlg+hcTMChangeAll;
Insert(PB);

R.Assign(37,6,46,8);
PB:=New(PButton,Init(R,'~+~ '#24,cmTDlgPlus,bfNormal));
PB^.HelpCtx:=hcDlg+hcTMPlus;
Insert(PB);
R.Assign(47,6,56,8);
PB:=New(PButton,Init(R,'~-~ '#25,cmTDlgMinus,bfNormal));
PB^.HelpCtx:=hcDlg+hcTMMinus;
Insert(PB);

R.Assign(2+Length(EditTempLabelStr),1,9+Length(EditTempLabelStr),2);
PI:=New(PInputLine,Init(R,5));
PI^.HelpCtx:=hcDlg+hcTMInputLine1;
Insert(PI);

R.Assign(2,1,2+Length(EditTempLabelStr),2);
Insert(New(PLabel,Init(R,EditTempLabelStr,PI)));


R.Assign(3+Length(EditTempLabelStr1)+8+Length(EditTempLabelStr),1,
   11+Length(EditTempLabelStr1)+8+Length(EditTempLabelStr),2);
PI1:=New(PInputLine,Init(R,6));
PI1^.HelpCtx:=hcDlg+hcTMInputLine2;
Insert(PI1);

R.Assign(2+8+Length(EditTempLabelStr),1,2+Length(EditTempLabelStr1)+8+Length(EditTempLabelStr),2);
Insert(New(PLabel,Init(R,EditTempLabelStr1,PI1)));

SelectNext(False);
Rat:=0;
end;

Procedure TTempDialog.HandleEvent;
var Code,Code1:integer;
    s:string[5];
    s1:string[6];
    r:real;
    L:Longint;
Begin
Inherited HandleEvent(E);
val(PInputLine(Last^.Next^.Next^.Next^.Next)^.Data^,L,Code);
if rat>0 then
begin
r:=rat;
val(PInputLine(Last^.Next^.Next)^.Data^,r,Code1)
end      else
begin
val(PInputLine(Last^.Next^.Next)^.Data^,rat,Code1);
r:=rat;
end;

If Round(L*r)>MaxTemp then Temp:=round(MaxTemp/r)else Temp:=L;
if(E.What=evKeyDown)and(Phase=phPostProcess)then
begin
E.What:=evCommand;
case E.KeyCode of
kbUp,kbRight :E.Command:=cmTDlgPlus ;
kbLeft,kbDown:E.Command:=cmTDlgMinus;
end{case}
end;{if}
str(temp,s);

if(E.What=evCommand)then
case E.Command of
cmTDlgPlus      : if Temp+TempIncr<MaxTemp then Inc(Temp,TempIncr)else Temp:=MaxTemp;
cmTDlgMinus     : if Temp>TempIncr then Dec(Temp,TempIncr)else Temp:=1;
cmTDlgChangeAll : EndModal(cmTDlgChangeAll)
else s:=''
end else s:='';
if temp=0 then begin temp:=1;str(temp,s)end;


with PInputline(Last^.Next^.Next^.Next^.Next)^ do
begin
if(s<>'')or(code<>0)or(Round(L*r)>MaxTemp)then
             begin
             str(temp,s);
             Data^:=copy(s,1,5);
             draw
             end;
val(Data^,L,Code);
end;
with PInputLine(Last^.Next^.Next)^ do
begin
if(code1<>0)or(r=0)then
                   begin
                   r:=rat;
                   str(r:1:3,s);
                   Data^:=copy(s,1,6);
                   draw
                   end
end;
if code=0 then PGraphicLine(Last^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next)^.setpos(Temp);
End;

Constructor TGraphicLine.Init;
Begin
R.B.Y:=R.A.Y+1;
Inherited Init(R);
Limit.X:=Max;
Limit.Y:=Min;
CurPos:=IniValue;
SetState(sfVisible,True);
SetState(sfDisabled,False);
SetState(sfExposed,True);
Options:=ofBuffered;
End;

Function  TGraphicLine.GetPalette;
Begin
GetPalette:=@CGraphLinePalette
end;

Procedure TGraphicLine.Draw;
var B:TDrawBuffer;
    I,J,K:word;
Begin
I:=round(Size.X*(CurPos-Limit.Y)*8/(Limit.X-Limit.Y));
J:=I shr 3;
Movechar(B,' ',Getcolor(1),Size.X);
if J>0 then movechar(B,'',Getcolor(1),J);
B[J]:=Getcolor(1)shl 8+ord(GraphicChars[i and 7]);
writeline(0,0,size.x,1,B);
End;

Procedure TGraphicLine.Add;
Begin
if P+Curpos>=Limit.X then Curpos:=Limit.X else Inc(Curpos,P);
Draw
End;

Procedure TGraphicLine.Subtruct;
Begin
if CurPos>P then Dec(Curpos,P) else CurPos:=0;
Draw
End;

Procedure TGraphicLine.SetPos;
Begin
If P<Limit.X then CurPos:=P else CurPos:=Limit.X;
Draw
end;


Procedure TGraphicLine.HandleEvent;
Begin
Inherited HandleEvent(E);
End;


Constructor TMyChdirDialog.Init;
Begin
Inherited Init(A,H);
ChdirButton^.HelpCtx:=hcDlg+hcChDirButton;
DirInput^.HelpCtx:=hcDlg+hcDirInput;
DirList^.HelpCtx:=hcDlg+hcDirList;
OkButton^.HelpCtx:=hcDlg+hcOkButton;
PButton(DirInput^.Next^.Next)^.HelpCtx:=hcDlg+hcRevertButton;
end;

Constructor TMyFileDialog.Init;
Begin
Inherited Init(AW,ATitle,InputName,AO,HI);
FileList^.HelpCtx:=hcDlg+hcFileList;
FileName^.HelpCtx:=hcDlg+hcFileInput;
FileName^.Next^.Next^.Next^.Next^.HelpCtx:=hcDlg+hcOpenButton;
FileName^.Next^.Next^.Next^.HelpCtx:=hcDlg+hcCancelButton;
end;

Destructor TMyFileDialog.Done;
var S:PathStr;
Begin
Case EndState of
cmFileOpen..cmFileClear:begin
                        GetFileName(S);
                        PHistory(Last^.Next^.Next^.Next^.Next^.Next^.Next^.Next)^.
                        RecordHistory(S);
                        end;
end;
Inherited Done;
end;


Constructor TOptFileDialog.Init;
var R:TRect;
    PI:PInputLine;
    PC:PCheckBoxes;
    PR:PRadioButtons;
    PB:PButton;
Begin
R.Assign(19,5,61,20);
Inherited Init(R,FileOptHeaderStr);
R.Assign(1+length(FOLabelStr1),1,2+sizeof(OptFileStr)+length(FOLabelStr1),2);
PI:=New(PInputLine,Init(R,sizeof(OptFileStr)-1));
PI^.HelpCtx:=hcDlg+hcFOInputLine1;
Insert(PI);
R.Assign(1,1,1+length(FOLabelStr1),2);
Insert(New(Plabel,Init(R,FOLabelStr1,PI)));

R.Assign(1+length(FOLabelStr2),3,2+sizeof(OptFileStr)+length(FOLabelStr2),4);
PI:=New(PInputLine,Init(R,sizeof(OptFileStr)-1));
PI^.HelpCtx:=hcDlg+hcFOInputLine2;
Insert(PI);
R.Assign(1,3,1+length(FOLabelStr2),4);
Insert(New(Plabel,Init(R,FOLabelStr2,PI)));

R.Assign(2,6,19,9);
PR:=New(PRadioButtons,Init(R,
    NewSItem(FORadioButStr1,
    NewSItem(FORadioButStr2,
    NewSItem(FORadioButStr3,Nil)))));
PR^.HelpCtx:=hcDlg+hcFORBkbStop1;
Insert(PR);
R.Assign(2,5,4+Length(FOLabelStr3),6);
Insert(New(PLabel,Init(R,FOLabelStr3,PR)));

R.Assign(21,6,38,9);
PR:=New(PRadioButtons,Init(R,
    NewSItem(FORadioButStr1,
    NewSItem(FORadioButStr2,
    NewSItem(FORadioButStr3,Nil)))));
PR^.HelpCtx:=hcDlg+hcFORBwrHdr1;
Insert(PR);
R.Assign(21,5,24+Length(FOLabelStr4),6);
Insert(New(PLabel,Init(R,FOLabelStr4,PR)));

R.Assign(2,10,40,11);
PC:=New(PCheckBoxes,Init(R,NewSItem(FOCheckBoxStr,Nil)));
PC^.HelpCtx:=hcDlg+hcFOEmptyOpen;
Insert(PC);
R.Assign(2,9,5+length(FOLabelStr5),10);
Insert(New(PLabel,Init(R,FOLabelStr5,PC)));

R.Assign(9,12,18,14);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcDlg+hcOkButton;
Insert(PB);

R.Assign(20,12,30,14);
PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
PB^.HelpCtx:=hcDlg+hcCancelButton;
Insert(PB);
SelectNext(False);
End;

Constructor TOptEditDialog.Init;
var R:TRect;
    PI:PInputLine;
    PC:PCheckBoxes;
    PR:PRadioButtons;
    PB:PButton;
Begin
R.Assign(9,6,71,19);
Inherited Init(R,EditOptHeaderStr);
R.Assign(2+Length(EOLabelStr1),1,2+1+sizeof(OptEditStr)+Length(EOLabelStr1),2);
PI:=New(PInputLine,Init(R,sizeof(OptEditStr)-1));
PI^.HelpCtx:=hcDlg+hcEOTempIncr;
Insert(PI);
R.Assign(1,1,1+Length(EOLabelStr1),2);
Insert(New(PLabel,Init(R,EOLabelStr1,PI)));

R.Assign(1+Length(EOLabelStr2),3,2+5+Length(EOLabelStr2)+Length(EOCheckBoxStr),4);
PC:=New(PCheckBoxes,Init(R,NewSItem(EOCheckBoxStr,Nil)));
PC^.HelpCtx:=hcDlg+hcEOMarkDown;
Insert(PC);
R.Assign(1,3,1+Length(EOLabelStr2),4);
Insert(New(PLabel,Init(R,EOLabelStr2,PC)));

R.Assign(1,6,28,9);
PR:=New(PRadioButtons,Init(R,NewSItem(EORadioButStr1,
                             NewSItem(EORadioButStr2,Nil))));
PR^.HelpCtx:=hcDlg+hcEOTMChangeAll1;
Insert(PR);
R.Assign(1,5,1+Length(EOLabelStr3),6);
Insert(New(PLabel,Init(R,EOLabelStr3,PR)));

R.Assign(29,6,60,9);
PR:=New(PRadioButtons,Init(R,NewSItem(EORadioButStr1,
                             NewSItem(EORadioButStr2,Nil))));
PR^.HelpCtx:=hcDlg+hcEOTRChangeAll1;
Insert(PR);
R.Assign(29,5,29+Length(EOLabelStr4),6);
Insert(New(PLabel,Init(R,EOLabelStr4,PR)));

R.Assign(16,10,26,12);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcDlg+hcOkButton;
Insert(PB);
R.Assign(30,10,42,12);
PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
PB^.HelpCtx:=hcDlg+hcCancelButton;
Insert(PB);
SelectNext(False);
End;


Constructor TOptPlayDialog.Init;
var R:TRect;
    PC:PCheckBoxes;
    PI:PInputLine;
    PB:PButton;
Begin
R.Assign(20,5,60,21);
Inherited Init(R,PlayOptHeaderStr);
R.Assign(2+Length(POLabelStr1),1,5+2+Length(POLabelStr1),2);
PI:=New(PInputLine,Init(R,Sizeof(OptPlayStr)-1));
PI^.HelpCtx:=hcDlg+hcPOAccCnt;
Insert(PI);
R.Assign(1,1,1+Length(POLabelStr1),2);
Insert(New(Plabel,Init(R,POLabelStr1,PI)));

R.Assign(2+Length(POLabelStr4),3,7+2+Length(POLabelStr4),4);
PI:=New(PInputLine,Init(R,Sizeof(OptPlayStr1)-1));
PI^.HelpCtx:=hcDlg+hcPOTMDiv;
Insert(PI);
R.Assign(1,3,2+Length(POLabelStr4),4);
Insert(New(Plabel,Init(R,POLabelStr4,PI)));

R.Assign(2+Length(POLabelStr5),5,7+2+Length(POLabelStr5),6);
PI:=New(PInputLine,Init(R,Sizeof(OptPlayStr1)-1));
PI^.HelpCtx:=hcDlg+hcPOTRMult;
Insert(PI);
R.Assign(1,5,2+Length(POLabelStr5),6);
Insert(New(Plabel,Init(R,POLabelStr5,PI)));

R.Assign(1+Length(POLabelStr2),7,37,10);
PC:=New(PCheckBoxes,Init(R,NewSItem(POCheckBoxStr1,
                           NewSItem(POCheckBoxStr3,
                           NewSItem(POCheckBoxStr4,Nil)))));

PC^.HelpCtx:=hcDlg+hcPOAutoSetup;
Insert(PC);
R.Assign(1,7,1+Length(POLabelStr2),8);
Insert(New(PLabel,Init(R,POLabelStr2,PC)));

R.Assign(1+Length(POLabelStr3),11,37,12);
PC:=New(PCheckBoxes,Init(R,NewSItem(POCheckBoxStr2,Nil)));
PC^.HelpCtx:=hcDlg+hcPOBlinking;
Insert(PC);
R.Assign(1,11,1+Length(POLabelStr3),12);
Insert(New(PLabel,Init(R,POLabelStr3,PC)));

R.Assign(6,13,16,15);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcDlg+hcOkButton;
Insert(PB);

R.Assign(22,13,34,15);
PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
PB^.HelpCtx:=hcDlg+hcCancelButton;
Insert(PB);
SelectNext(False);
End;

Procedure TOptPlayDialog.HandleEvent;
var S:PString;
    c:word;
    Code:Integer;
begin
Inherited HandleEvent(E);
{S:=PInputLine(Last^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next)^.Data;
val(S^,C,Code);
if(Code=0)and(C>1)then ;}
end;

Constructor TOptPrefDialog.Init;
var R:TRect;
    PR:PRadioButtons;
    PC:PCheckBoxes;
    PB:PButton;
Begin
R.Assign(15,6,65,19);
Inherited Init(R,ROHeaderStr);
R.Assign(2,2,23,4);
PR:=New(PRadioButtons,Init(R,NewSItem(RORadioButStr1,
                             NewSItem(RORadioButStr2,Nil))));
Pr^.EnableMask:=PR^.EnableMask and not(3*ord((not hiresscreen)));
PR^.HelpCtx:=hcDlg+hcScrSize1;
Insert(PR);
R.Assign(1,1,2+Length(ROLabelStr1),2);
Insert(New(PLabel,Init(R,ROLabelStr1,PR)));

R.Assign(24,2,48,5);
PC:=New(PCheckBoxes,Init(R,NewSItem(ROCheckBoxStr1,
                           NewSItem(ROCheckBoxStr2,
                           NewSItem(ROCheckBoxStr3,Nil)))));
PC^.HelpCtx:=hcDlg+hcAutoSave;
Insert(PC);
R.Assign(24,1,48,2);
Insert(New(PLabel,Init(R,ROLabelStr2,PC)));

R.Assign(2,6,48,9);
PR:=New(PRadioButtons,Init(R,NewSItem(RORadioButStr4,
                             NewSItem(RORadioButStr5,
                             NewSItem(RORadioButStr6,Nil)))));
PR^.HelpCtx:=hcDlg+hcScrMode1;
Insert(PR);
R.Assign(1,5,2+Length(ROLabelStr3),6);
Insert(New(Plabel,Init(R,ROLabelStr3,PR)));
R.Assign(8,10,18,12);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcDlg+hcOkButton;
Insert(PB);
R.Assign(22,10,34,12);
PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
PB^.HelpCtx:=hcDlg+hcCancelButton;
Insert(PB);

SelectNext(False);
End;


function TClickTester.GetPalette: PPalette;
const
  P: String[Length(CClickTester)] = CClickTester;
begin
  GetPalette := @P;
end;

procedure TClickTester.HandleEvent(var Event: TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What = evMouseDown) then
  begin
    if Event.Double then
    begin
      Clicked := not Clicked;
      DrawView;
    end;
    ClearEvent(Event);
  end;
end;

procedure TClickTester.Draw;
var
  B: TDrawBuffer;
  C: Byte;
begin
  if Clicked then C := GetColor(2)
  else C := GetColor(1);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, Text^, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

constructor TMouseDialog.Init;
var
  R: TRect;
  PC:PCheckBoxes;
  PB:PButton;
begin
  R.Assign(0, 0, 34, 12);
  inherited Init(R, MouseOptHeadeStr);
  Options := Options or ofCentered;

  R.Assign(3, 4, 30, 5);
  MouseScrollBar := New(PScrollBar, Init(R));
  MouseScrollBar^.SetParams(1, 1, 20, 20, 1);
  MouseScrollBar^.Options := MouseScrollBar^.Options or ofSelectable;
  MouseScrollBar^.SetValue(DoubleDelay);
  MouseScrollBar^.HelpCtx:=hcDlg+hcDoubleClick;
  Insert(MouseScrollBar);
  R.Assign(2, 2, 21, 3);
  Insert(New(PLabel, Init(R, MOLabelStr1, MouseScrollBar)));

  R.Assign(3, 3, 30, 4);
  Insert(New(PClickTester, Init(R, MOLabelStr2)));

  R.Assign(3, 6, 30, 7);
  PC:=New(PCheckBoxes, Init(R,
    NewSItem(MOCheckBoxStr, nil)));
  PC^.HelpCtx:=hcDlg+hcMSReverse;
  Insert(PC);

  OldDelay := DoubleDelay;

  R.Assign(9, 9, 19, 11);
  PB:=New(PButton, Init(R, 'O~K~', cmOk, bfDefault));
  PB^.HelpCtx:=hcDlg+hcOKButton;
  Insert(PB);
  Inc(R.A.X, 12); Inc(R.B.X, 12);
  PB:=New(PButton, Init(R, 'Cancel', cmCancel, bfNormal));
  PB^.HelpCtx:=hcDlg+hcCancelButton;
  Insert(PB);

  SelectNext(False);
end;

procedure TMouseDialog.HandleEvent(var Event: TEvent);
begin
  if (Event.What = evCommand) and (Event.Command = cmCancel) then
    DoubleDelay := OldDelay;
  inherited HandleEvent(Event);
  case Event.What of
    evBroadcast:
      if Event.Command = cmScrollBarChanged then
      begin
        DoubleDelay := MouseScrollBar^.Value;
        ClearEvent(Event);
      end;
  end;
end;


Constructor TAboutDialog.Init;
var R:TRect;
    PB:PButton;
begin
R.Assign(21,6,59,19);
Inherited Init(R,'About');
R.Assign(1,1,37,2);
Insert(New(PStaticText,Init(R,#3'  007  ')));
R.Assign(1,2,37,3);
Insert(New(PStaticText,Init(R,#3'')));
R.Assign(1,3,37,4);
Insert(New(PStaticText,Init(R,#3'樠쭮 ')));
R.Assign(1,4,37,5);
Insert(New(PStaticText,Init(R,#3'')));
R.Assign(1,5,37,6);
Insert(New(PStaticText,Init(R,#3'몠쭮 ।')));
R.Assign(1,6,37,7);
Insert(New(PStaticText,Init(R,#3'006')));
R.Assign(1,7,37,8);
Insert(New(PStaticText,Init(R,#3'  ࢠ ..')));
R.Assign(1,8,37,9);
Insert(New(PStaticText,Init(R,#3',(C) 1996')));
R.Assign(14,10,24,12);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcAboutDlg;
Insert(PB);
end;

{Constructor TAutoButton.Init;
begin
Inherited Init(Bounds,ATitle,ACommand,AFlags);
EventMask:=EventMask or evMouseAuto;
end;

Procedure TAutoButton.HandleEvent;
var ClickRect:TRect;
    Mouse:TPoint;
begin
Inherited HandleEvent(E);
if(E.What and evMouseAuto)<>0 then
begin
  GetExtent(ClickRect);
  Inc(ClickRect.A.X);
  Dec(ClickRect.B.X);
  Dec(ClickRect.B.Y);
  MakeLocal(E.Where, Mouse);
  if ClickRect.Contains(Mouse) then Press;
end;
end;}

{Constructor TSysInfoDlg.Init;
var S,s1:string;
    i:word;
    R:TRect;
    PB:Pbutton;
Begin
R.Assign(20,5,60,20);
Inherited Init(R,InfHeaderStr);
i:=dosversion;
str(Lo(i),s);
str(Hi(i),s1);
s:=' DOS : '+s+'.'+s1;
R.Assign(2,1,39,2);
Insert(New(PStaticText,Init(R,s)));
s:=' : '+CPU_TypeStr;
R.Assign(2,4,39,5);
s:=CoPro_TypeStr;
if s='Unknown' then s:='';
if s='None'    then s:='';
s:=' : '+s;
Insert(New(PStaticText,Init(R,s)));
str(MemAvail/1024:1:0,s);
s:='ணࠬ 㯭 ᢮  : '+s+'Kb';
R.Assign(2,6,39,7);
Insert(New(PStaticText,Init(R,s)));
R.Assign(15,12,25,14);
PB:=New(PButton,Init(R,'O~K~',cmOk,bfDefault));
PB^.HelpCtx:=hcDlg+hcSingleButton;
Insert(PB);
End;}

Procedure Translate(var S:string);
Begin
if s='Invalid file name.' then s:=emInvalidFileName;
if s='Invalid drive or directory.' then s:=emInvalidPath;
if s='Invalid directory.' then s:=emInvalidDirectory;
End;

Function MessageBox;
Var PD:PDialog;
    Message,S:string;
    PS:PStaticText;
    PB:PButton;
    R:TRect;
    I,J,K:word;
    Height:word;
Begin
if Application=Nil then exit;
if AOptions and mfWarning     =mfWarning      then S:=mfWarningStr;
if AOptions and mfError       =mfError        then S:=mfErrorStr  ;
if AOptions and mfConfirmation=mfConfirmation then S:=mfConfirmationStr;
if AOptions and mfInformation =mfInformation  then S:=mfInformationStr;
if Params<>Nil then FormatStr(Message,Msg,Params^)
               else Message:=Msg;
Translate(Message);
Height:=mbHeight;
J:=0;
for I:=1 to length(Message)do if Message[i]=#13 then inc(J);
inc(J,Length(Message)div(mbWidth-2));
if J+8<Height then Height:=J+8;
R.Assign((ScreenWidth-mbWidth)div 2,(ScreenHeight-Height)div 2,
         (ScreenWidth+mbWidth)div 2,(ScreenHeight+Height)div 2);
PD:=New(PDialog,Init(R,S));
If PD=Nil then exit;
With PD^ do
   begin
   R.Assign(1,1,pred(mbWidth),pred(Height));
   PS:=New(PStaticText,Init(R,Message));
   PS^.Options:=PS^.Options or ofCenterY;
   Insert(PS);

   I:=0;{I - Buttons Count}
   If AOptions and mfYesButton   <>0 then Inc(I);
   If AOptions and mfNoButton    <>0 then Inc(I);
   If AOptions and mfOkButton    <>0 then Inc(I);
   If AOptions and mfCancelButton<>0 then Inc(I);
   J:=(mbWidth-(I*mbButtonSize))div(I+1);{J = space between the buttons}
   K:=J;
   If AOptions and mfYesButton   <>0 then
   begin R.Assign(K,Height-3,K+mbButtonSize,Height-1);
         PB:=New(PButton,Init(R,'~Y~es',cmYes,bfDefault));
         PB^.HelpCtx:=hcDlg+hcYesButton;
         Insert(PB);
         Inc(K,J+mbButtonSize)
   end;
   If AOptions and mfNoButton    <>0 then
   begin R.Assign(K,Height-3,K+mbButtonSize,Height-1);
         PB:=New(PButton,Init(R,'~N~o',cmNo,bfNormal));
         PB^.HelpCtx:=hcDlg+hcNoButton;
         Insert(PB);
         Inc(K,J+mbButtonSize)
   end;
   If AOptions and mfOkButton    <>0 then
   begin R.Assign(K,Height-3,K+mbButtonSize,Height-1);
         PB:=New(PButton,Init(R,'O~K~',cmOK,bfDefault-ord(AOptions and mfYesButton<>0)));
         PB^.HelpCtx:=hcDlg+hcOkButton;
         Insert(PB);
         Inc(K,J+mbButtonSize)
   end;
   If AOptions and mfCancelButton<>0 then
   begin R.Assign(K,Height-3,K+mbButtonSize,Height-1);
         PB:=New(PButton,Init(R,'~C~ancel',cmCancel,bfNormal));
         PB^.HelpCtx:=hcDlg+hcCancelButton;
         Insert(PB);
         Inc(K,J+mbButtonSize)
   end;
   SelectNext(False)
   end;
   MessageBox:=Application^.ExecView(PD)
End;
constructor TClickTester.Init(var Bounds: TRect; AText: String);
begin
  inherited Init(Bounds, AText);
  Clicked := False;
end;


End{OF UNIT}.