Unit MenuStatus;
Interface
Uses App,Objects,Menus,Views,Drivers,AppConst;
var  ReadWriteName:FNamestr;

type
PMyStatusLine=^TMyStatusLine;
TMyStatusLine=Object(TStatusLine)
Function Hint(Ctx:word):string;Virtual;
End;

PLikeMyWindow=^TLikeMyWindow;
TLikeMyWindow=object(TWindow){The way to refer TMyWindow fields without
                              using AppMain}
Num:Byte;
MColl:Pointer;
Name,{File Name}
Header:Pstring;
CurPos,CurPart,
upLine,dnLine:word;
MainOwner:Pointer;
Interior:Pointer;
WinComSet:TCommandset;
Modified,
Playing:boolean;
Cur8:array[1..8]of byte;
end;

PLikeMainApp=^TLikeMainApp;
TLikeMainApp=object(TApplication)
CurWin:byte;
WinList:array[0..9]of PLikeMyWindow;
End;

var SaveCfgMenuItemPtr:PMenuItem;





Function MyStatusLine(var R:TRect):PStatusLine;
Function MyMenuBar(Var R:Trect):PMenuBar;
Implementation

Function CurWinFileName:string;{Current window file name}
var P:Pointer;
Begin
with PLikeMainApp(Application)^ do
P:=WinList[CurWin];
If PLikeMyWindow(P)^.Name<>Nil then CurWinFileName:=PLikeMyWindow(P)^.Name^
                               else CurWinFileName:=''
end;

Function CurWinTitle:string;{Current window title}
var P:Pointer;
Begin
with PLikeMainApp(Application)^ do
P:=WinList[CurWin];
If PWindow(P)^.Title<>Nil then CurWinTitle:=PWindow(P)^.Title^
                          else CurWinTitle:=''
end;

Function TMyStatusLine.Hint;
var I:byte;
    s:string;
Begin
Case Ctx of
{hcPlaying,
hcPlayingAll:begin
             s:=CurWinTitle;
             for i:=length(s) downto 1 do if s[i]='\'then break;
             if not((I=1)and(s[1]<>'\'))then delete(s,1,i);
             Hint:=GetHintStr(Ctx)+s;
             end;}
hcSaving,
hcReading:Hint:=GetHintStr(Ctx)+ReadWriteName;
else Hint:=GetHintStr(Ctx)
End;{Case}
End;


Function MyStatusLine;
Begin
MyStatusLine:=new(PMyStatusLine,Init(R,
              NewStatusDef(0,0,
              NewStatusKey('',kbAltX,cmQuit,
              NewStatusKey('~Shift+F3~ O COM',kbShiftF3,cmReadCom,
              NewStatusKey('',kbF2,cmSave,
              NewStatusKey('~F3~ O ANN',kbF3,cmOpen,
              NewStatusKey('~F9~ ᯮ ',kbF9,cmPlay,
              NewStatusKey('~F10~ ',kbF10,cmMenu,
              NewStatusKey('',kbAltF3,cmClose,
              NewStatusKey('',kbF5,cmZoom,
              NewStatusKey('',kbF6,cmNext,
              NewStatusKey('',kbShiftF6,cmPrev,
              NewStatusKey('',kbCtrlF5,cmResize,
              NewStatusKey('',kbIns,cmMark,
              NewStatusKey('',kbShiftDel,cmCut,
              NewStatusKey('',kbCtrlIns,cmCopy,
              NewStatusKey('',kbShiftIns,cmPaste,
              NewStatusKey('',kbCtrlDel,cmClear,
              NewStatusKey('',kbAltH,cmEditHeader,
              NewStatusKey('',kbAltM,cmEditTemp,
              NewStatusKey('',kbAltR,cmEditTransp,
              NIL
              ))))))))))))))))))),
              NewStatusDef(hcDragging,hcDragging,
              NewStatusKey('~'#24#25#26#27'~ ',kbNoKey,0,
              NewStatusKey('~Shift+'#24#25#26#27'~  ࠧ',kbNoKey,0,
              NewStatusKey('~~ ⠭',kbNoKey,0,
              NewStatusKey('~Esc~ ⪠',kbNoKey,0,
              Nil
              )))),
              NewStatusDef(hcPlaying,hcPlayingAll,
              NewStatusKey('~Stop~',kbAltS,cmQuit,
              Nil
              ),
              NewStatusDef(0,$FFFF,
              NewStatusKey('',kbAltX,cmQuit,
              NewStatusKey('',kbAltF3,cmClose,
              NewStatusKey('',kbF5,cmZoom,
              NewStatusKey('',kbF6,cmNext,
              NewStatusKey('',kbShiftF6,cmPrev,
              NewStatusKey('',kbCtrlF5,cmResize,
              Nil
              )))))),
              Nil
              ))))));
End;

Function MyMenuBar;
Begin
SaveCfgMenuItemPtr:=NewItem('~S~ave','',kbNoKey,cmOptSave,hcMenu+hcOptSave,
    NewItem('Save ~a~s...','',kbNoKey,cmOptSaveAs,hcMenu+hcOptSaveAs,
    NIL
  ));
MyMenuBar:=New(PMenuBar,Init(R,NewMenu(
  NewSubMenu('~F~ile',hcMenu+hcFile, NewMenu(
  NewItem('~N~ew','',kbNoKey ,cmNew,hcMenu+hcNew,
  NewItem('~O~pen...','F3',kbF3 ,cmOpen,hcMenu+hcOpen,
  NewItem('~S~ave ','F2',kbF2 ,cmSave,hcMenu+hcSave,
  NewItem('Save a~l~l','',kbNoKey ,cmSaveAll,hcMenu+hcSaveAll,
  NewItem('Save ~a~s...','',kbNoKey ,cmSaveAs,hcMenu+hcSaveAs,
  NewItem('Read Co~m~...','Shift+F3',kbShiftF3,cmReadCom,hcMenu+hcReadCom,
  NewItem('~R~ead Snd...','Ctrl+F3',kbCtrlF3,cmReadSnd,hcMenu+hcReadSnd,
  NewItem('~W~rite Com...','Shift-F2',kbShiftF2,cmWriteCom,hcMenu+hcWriteCom,
  NewItem('~D~OS Shell','',kbNoKey,cmDosShell,hcMenu+hcDosShell,
  NewItem('~C~h Dir','',kbNoKey,cmChangeDir,hcMenu+hcChDir,
  NewItem('E~x~it','',kbNoKey,cmQuit,hcMenu+hcQuit,
  NIL
  )))))))))))),
  NewSubMenu('~E~dit',hcMenu+hcEdit, NewMenu(
    NewItem('Cu~t~','Shift+Del',kbShiftDel,cmCut,hcMenu+hcCut,
    NewItem('~C~opy','Ctrl+Ins',kbCtrlIns,cmCopy,hcMenu+hcCopy,
    NewItem('~P~aste','Shift+Ins',kbShiftIns,cmPaste,hcMenu+hcPaste,
    NewItem('C~l~ear','Ctrl+Del',kbCtrlIns,cmClear,hcMenu+hcClear,
    NewItem('~M~ark','Ins',kbIns,cmMark,hcMenu+hcMark,
    NewLine(
    NewItem('~H~eader...','Alt+H',kbAltH,cmEditHeader,hcMenu+hcHeader,
    NewItem('Te~m~p...','Alt+M',kbAltM,cmEditTemp,hcMenu+hcTemp,
    NewItem('T~r~ansp...','Alt+R',kbAltR,cmEditTransp,hcMenu+hcTransp,
    NewLine(
    NewItem('Run 00~6~','Alt+F6',kbAltF6,cmEditRun006,hcMenu+hcRun006,
    NIL
  )))))))))))),
  NewSubMenu('~P~lay',hcMenu+hcPlay_, NewMenu(
    NewItem('~P~lay','F9',kbF9,cmPlay,hcMenu+hcPlay,
    NewItem('Play ~a~ll','Ctrl+F9',kbCtrlF9,cmPlayAll,hcMenu+hcPlayAll,
    NewItem('Play on ~d~isplay','',kbNoKey,cmPlayOnScreen,hcMenu+hcPlayOnScreen,
    NIL
  )))),
  NewSubMenu('~O~ptions',hcMenu+hcOptions, NewMenu(
    NewItem('~F~ile...','',kbNoKey,cmOptFile,hcMenu+hcOptFile,
    NewItem('~E~dit...','',kbNoKey,cmOptEdit,hcMenu+hcOptEdit,
    NewItem('~P~lay...','',kbNoKey,cmOptPlay,hcMenu+hcOptPlay,
    NewItem('P~r~eferences...','',kbNoKey,cmOptPrefer,hcMenu+hcOptPrefer,
    NewItem('~M~ouse...','',kbNoKey,cmOptMouse,hcMenu+hcOptMouse,
    NewLine(
    NewItem('~O~pen...','',kbNoKey,cmOptOpen,hcMenu+hcOptOpen,
    SaveCfgMenuItemPtr
  )))))))),
  NewSubMenu('~W~indow',hcMenu+hcWindow,NewMenu(
    NewItem('~T~ile','',kbNoKey,cmTile,hcMenu+hcTile,
    NewItem('~C~ascade','',kbNoKey,cmCascade,hcMenu+hcCascade,
    NewItem('Cl~o~se all','',kbNoKey,cmCloseAll,hcMenu+hcCloseAll,
    NewLine(
    NewItem('~S~ize/Move','Ctrl-F5',kbCtrlF5,cmResize,hcMenu+hcResize,
    NewItem('~Z~oom','F5',kbF5,cmZoom,hcMenu+hcZoom,
    NewItem('~N~ext','F6',kbF6,cmNext,hcMenu+hcNext,
    NewItem('~P~revious','Shift-F6',kbShiftF6,cmPrev,hcMenu+hcPrevious,
    NewItem('~C~lose','Alt-F3',kbAltF3,cmClose,hcMenu+hcClose,
    Nil
    )))))))))),
  Nil
))))))));
end;


end.






